		AREA	HelloWT,CODE,READONLY
SWI_ANGEL   EQU 0x123456		;SWI number for Angel semihosting from arm code
SWI_TANGEL	EQU	0xAB			;SWI number for Angel semihosting from thumb code

		MACRO
$l		Exit					;Angel SWI call to terminate execution
$l		MOV		r0, #0x18		;select Angel SWIreason_ReportException(0x18)
		LDR     r1, =0x20026	;report ADP_Stopped_ApplicationExit
		SWI 	SWI_ANGEL		;ARM semihosting SWI
		MEND

		MACRO
$l		TExit					;Angel SWI call to terminate execution
$l		MOV		r0, #0x18		;select Angel SWIreason_ReportException(0x18)
		LDR     r1, =0x20026	;report ADP_Stopped_ApplicationExit
		SWI		SWI_TANGEL		;THUMB semihosting SWI
		MEND


		MACRO
$l		WriteC					;Angel SWI call to output character in [r1]
$l		MOV		r0, #0x3		;select Angel SYS_WRITEC function
		SWI		SWI_ANGEL		;ARM semihosting SWI
		MEND

		MACRO
$l		TWriteC					;Angel SWI call to output character in [r1]
$l		MOV		r0, #0x3		;select Angel SYS_WRITEC function
		SWI		SWI_TANGEL		;THUMB semihosting SWI
		MEND






		ENTRY					;code entry point
		CODE32					;enter in ARM state
		ADR		r0, START+1		;get Thumb entry address
		BX		r0				;enter Thumb area
		CODE16
		
		
START	ADR		r1, TEXT		;r1->"Hello World"
		MOV		r0, #0x3		;select Angel SYS_WRITEC
LOOP	LDRB	r2, [r1]		;get next byte
		CMP		r2, #0			;check for text end
		BEQ 	DONE			;finished?           **T
		SWI		SWI_TANGEL		;if not end print...
		ADD		r1, r1, #1		;increment pointer   **T
		B	LOOP				;..and loop back
DONE	TExit					;end of execution
		ALIGN					;to ensure ADR works
TEXT	DATA
		=	"Hello World",&a,&d,0
		END						;end of program source		
		
		
		
		
		